<template>
  <div
    :id="actualGroupName"
    ref="radioGroupRef"
    role="radiogroup"
    aria-label="radio-group"
    :aria-labelledby="actualGroupName"
    class="ui-radio-group"
  >
    <slot />
  </div>
</template>

<script setup lang="ts">
const emit = defineEmits(["update:modelValue"]);
const props = defineProps({
  modelValue: {
    type: String,
    required: true,
  },
  groupName: {
    type: String,
    required: false,
    default: "",
  },
});
const radioGroupRef = ref<HTMLDivElement>();
const id = ref<string>((Math.random() + 1).toString(36).substring(2, 8));
const actualGroupName = computed(() => {
  if (props.groupName && props.groupName.length > 0) return props.groupName;
  return `ui-radiogroup-${id.value}`;
});
const selected = computed({
  get: () => props.modelValue,
  set: (value: string) => emit("update:modelValue", value),
});

provide(RADIO_GROUP_KEY, {
  selected,
  groupName: actualGroupName,
});

onMounted(() => {
  const group = radioGroupRef.value;
  if (!group) return;
  const radios = group.querySelectorAll<HTMLInputElement>("[type=radio]");
  const firstLabel = radios[0];
  if (!Array.from(radios).some((radio) => radio.checked) && firstLabel) {
    firstLabel.tabIndex = 0;
  }
});
</script>

<style scoped></style>
